unit uPluginContactos;

interface

uses
  uModuleController, uInterfaces, uHostManager, Menus, Classes, ActnList,
  ImgList, Controls, PngImageList, uConfiguracionController, uIViewConfiguracionBase;

type
  IMCContactos = interface
    ['{BAEDC5D8-2FE8-4907-8027-C60861829BA9}']
  end;

  TPluginContactos = class(TModuleController, IMCContactos) //, IPluginConfigurable)
    actClientes: TAction;
    actProveedores: TAction;
    Compras1: TMenuItem;
    ExtraImages: TPngImageList;
    LargeImages: TPngImageList;
    MainMenu: TMainMenu;
    ModuleActionList: TActionList;
    Proveedores1: TMenuItem;
    Resumen1: TMenuItem;
    SmallImages: TPngImageList;
    Ventas1: TMenuItem;
    actVendedores: TAction;
    Vendedores1: TMenuItem;
    actGruposCliente: TAction;
    actGruposProveedor: TAction;
    Gruposdeproveedor1: TMenuItem;
    Da1: TMenuItem;
    actProcedenciasCliente: TAction;
    Procedenciasdecliente1: TMenuItem;
    Empresas1: TMenuItem;
    procedure actClientesExecute(Sender: TObject);
    procedure actProveedoresExecute(Sender: TObject);
    procedure actVendedoresExecute(Sender: TObject);
    procedure actGruposClienteExecute(Sender: TObject);
    procedure actGruposProveedorExecute(Sender: TObject);
    procedure actProcedenciasClienteExecute(Sender: TObject);
    function GetVistaConfiguracion : TClass;
    function GetEtiquetaConfiguracion : String;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

implementation

{$R *.dfm}

uses
  Forms, Dialogs, uGUIBase, uCustomEditor, SysUtils, uContactosController,
  uClientesController, uProveedoresController, uVendedoresController,
  uGruposClienteController, uProcedenciasClienteController, uBizGruposCliente,
  uGruposProveedorController, uBizGruposProveedor, uBizProcedenciasCliente,
  uContactosViewRegister, uBizContactos, uViewConfiguracionContactos;

function GetModule : TModuleController;
begin
  Result := TPluginContactos.Create(NIL);
end;

exports
  GetModule name GET_MODULE_FUNC;

{
******************************* TModuleContactos *******************************
}
procedure TPluginContactos.actClientesExecute(Sender: TObject);
var
  AClientesController : IClientesController;
  AClientes : IBizCliente;
begin
  try
  AClientesController := TClientesController.Create;
  AClientes := (AClientesController.BuscarTodos as IBizCliente);
  AClientesController.VerTodos(AClientes);
  finally
    AClientes := Nil;
    AClientesController := Nil; 
  end;
end;

procedure TPluginContactos.actGruposClienteExecute(Sender: TObject);
var
  AGruposClienteController : IGruposClienteController;
  AGruposCliente : IBizGrupoCliente;
begin
  AGruposClienteController := TGruposClienteController.Create;
  AGruposCliente := (AGruposClienteController.BuscarTodos as IBizGrupoCliente);
  AGruposClienteController.VerTodos(AGruposCliente);
end;

procedure TPluginContactos.actGruposProveedorExecute(Sender: TObject);
var
  AGruposProveedorController : IGruposProveedorController;
  AGruposProveedor : IBizGrupoProveedor;
begin
  AGruposProveedorController := TGruposProveedorController.Create;
  AGruposProveedor := (AGruposProveedorController.BuscarTodos as IBizGrupoProveedor);
  AGruposProveedorController.VerTodos(AGruposProveedor);
end;

procedure TPluginContactos.actProcedenciasClienteExecute(Sender: TObject);
var
  AProcedenciasClienteController : IProcedenciasClienteController;
  AProcedenciasCliente : IBizProcedenciaCliente;
begin
  AProcedenciasClienteController := TProcedenciasClienteController.Create;
  AProcedenciasCliente := (AProcedenciasClienteController.BuscarTodos as IBizProcedenciaCliente);
  AProcedenciasClienteController.VerTodos(AProcedenciasCliente);
end;

procedure TPluginContactos.actProveedoresExecute(Sender: TObject);
var
  AProveedoresController : IProveedoresController;
  AProveedores : IBizProveedor;
begin
  AProveedoresController := TProveedoresController.Create;
  AProveedores := (AProveedoresController.BuscarTodos as IBizProveedor);
  AProveedoresController.VerTodos(AProveedores);
end;

procedure TPluginContactos.actVendedoresExecute(Sender: TObject);
var
  AVendedoresController : IVendedoresController;
  AVendedores : IBizVendedor;
begin
  AVendedoresController := TVendedoresController.Create;
  AVendedores := (AVendedoresController.BuscarTodos as IBizVendedor);
  AVendedoresController.VerTodos(AVendedores);
end;

constructor TPluginContactos.Create(AOwner: TComponent);
begin
  inherited;
  uContactosViewRegister.RegisterViews;
end;

destructor TPluginContactos.Destroy;
begin
  uContactosViewRegister.UnregisterViews;
  inherited;
end;

function TPluginContactos.GetEtiquetaConfiguracion: String;
begin
  Result := TfrViewConfiguracionContactos.DarEtiqueta;
end;

function TPluginContactos.GetVistaConfiguracion: TClass;
begin
  Result := TfrViewConfiguracionContactos.GetViewClass;
end;

initialization
  uHostManager.RegisterModuleClass(TPluginContactos);

finalization
  uHostManager.UnRegisterModuleClass(TPluginContactos);

end.
